#include "ti86asm.inc"

.org _asm_exec_ram

_endSymbolTable		=		$D298
spritetempmem		=		$CA00
programtoedit		=		$8103
patchtype			=		$8102

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ProgStart:
	call _runindicoff
	call _flushallmenus
	set graphdraw,(iy + graphflags)
	call drawtitle
	ld hl, Option1
	call drawstring
	call getpatch
	cp 255
	ret z
	ld a, (hl)
	inc a
	ld e, a
	ld d, 0
	add hl, de
	ld a, (hl)
	ld (spritenum), a
	inc hl
	ld a, (hl)
	ld (endofsprites), a
	inc hl
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld (startofpatches), hl
	ld (stringsize), de
mainpatchmenu:
	call drawtitle
	ld hl, Option2
	call drawstring					;my draw string routine is nice enough to save de, and 
	ld de, $1a05					;hl is automatically placed at the start of the next string
	call drawstring					;with _vputs, so these are alot of smaller
	ld d, $20
	call drawstring
	ld d, $26
	call drawstring
	ld d, $2C
	call drawstring
	ld d, $32
	call drawstring
	ld d, $38
	call drawstring
	set graphdraw,(iy + graphflags)
	ld bc, $1a38
	ld d, 6
	xor a
	call blinkselect
	cp 255
	ret z
	cp 0
	call z, singlechange
	cp 1
	call z, turnallpatcheson
	cp 2
	call z, turnallpatchesoff
	cp 3
	call z, editminipatch
	cp 4
	call z, lockpatch
	cp 5
	call z, deleteminipatch
	jr mainpatchmenu
singlechange:
	ld a, (patchtype)
	cp 3
	jr z, illegalpatchoption
	call drawpatchnames
	cp 255
	ret z
	call switchstatus
	jr singlechange
illegalpatchoption:
	ld hl, illegalstring
	jp piodisplayerror
editminipatch:
	ld a, (patchtype)
	cp 2
	jr nc, illegalpatchoption
	call drawpatchnames
	ld c, a
	cp 255
	ret z
	inc hl
	ld a, (hl)
	cp 63
	jr z, mpatchdangerous
	dec hl
	ld a, (hl)
	and %10000000
	jr nz, patchison
	call editthatpatch
	jr editminipatch
mpatchdangerous:
	ld hl, minipatcherror
	call piodisplayerror
	jr editminipatch
patchison:
	ld hl, patchonstring
	call piodisplayerror
	jr editminipatch
lockpatch:
	ld a, (patchtype)
	cp 2
	jr nc, illegalpatchoption
	call drawtitle					;sets de to $1101
	ld hl, Option3
	call drawstring
	ld de, $1a05
	call drawstring
	ld d, $20
	call drawstring
	ld bc, $1a20
	ld d, 6
	xor a
	call blinkselect
	cp 255
	ret z
	inc a
	inc a
	ld (patchtype), a
	jp savestring
deleteminipatch:
	ld a, (patchtype)
	cp 2
	jp nc, illegalpatchoption
	call drawpatchnames
	cp 255
	ret z
	ld c, a
	push hl										;push the de for the ldir at the end
	ld a, (hl)
	ld hl, 8
	ld e, a
	ld d, 0
	add hl, de
	push hl										;..and the difference of de + hl (have to add de later)
	ex de, hl
	ld hl, (stringsize)
	sbc hl, de
	ld (stringsize), hl
	push hl										;..and the bc!
	ex de, hl
	ld hl, (startofpatches)
	dec hl
	ld (hl), d
	dec hl
	ld (hl), e
	dec hl
	ld a, (hl)
	cp c
	call nc, deccur
	ld (endofsprites), a
	dec hl
	call deccur
	ld (spritenum), a
	pop bc
	pop hl
	pop de			
	add hl, de
	ldir
	jp savestring
deccur:
	ld a, (hl)
	dec a
	ld (hl), a
	ret
	
piodisplayerror:
	push hl
	call _clrLCD
	pop hl
	ld de, $1d01
	call drawstring
	jp _pause

turnallpatcheson:
	xor a
	ld (allpatchcheck), a
	jr turnallpatches
turnallpatchesoff:
	ld a, 128
	ld (allpatchcheck), a
turnallpatches:
	ld a, (spritenum)
	ld hl, (startofpatches)
	ld b, a
taploop:
	push bc
	push hl
	ld a, (allpatchcheck)
	ld b, a
	ld a, (hl)
	and %10000000
	cp b
	call z, switchstatus
	pop hl
	pop bc
	push bc
	ld a, (spritenum)
	inc a
	sub b
	call getstartofminipatch
	pop bc
	djnz taploop
	xor a
	ret
ShellTitle:
	.db "The Shark Patcher v1.2", 0

makertitle:
	.db "By: Thomas Williamson, Biobytes",0

Option1:
	.text "Load Patch File"

Option2:
	.text "Select an Option"

PatchOp1:
	.text "Enable/Disable Single Mini-Patch"

PatchOp2:
	.text "Turn on all patches"

PatchOp3:
	.text "Turn off all patches"

PatchOp4:
	.text "Edit Mini-Patch Data"

PatchOp5:
	.text "Lock Current Patch"

PatchOp6:
	.text "Delete Minipatch"

Option3:
	.text "Warning! There is no going back!"

Plock1:
	.text "Medium Lock-No Editing"

Plock2:
	.text "Max Lock-All On and Off Only"

Offstring:
	.text "Off"

Onstring:
	.text "On"

spatchtext:
	.text "Select a Mini-Patch"

nextstring:
	.text "Next"

patchonstring:
	.text "You cannot edit patches that are on!"
illegalstring:
	.text "Patch is locked from this action!"
bytestring:
	.text "Byte:"
byteinfostring:
	.text "Byte Info:"
exitstring:
	.text "Exit-Exit and Save"
alphastring:
	.text "Alpha-Exit"
changestring:
	.text "Change:"
minipatcherror:
	.text "This M-Patch is too risky to edit!"

SharkLogo:									;this is very confusing to look at in a sprite editor
	.db %11111111
	.db %10000001 
	.db %10000001 
	.db %10000001 
	.db %01111110 
	.db %01111110 
	.db %01111101 
	.db %01111011
	.db %11111111
	.db %10000011
	.db %10011101
	.db %01100001
	.db %11111110
	.db %11111110
	.db %11011110
	.db %10101100
	.db %10001010 
	.db %10010000 
	.db %10010010 
	.db %10010101 
	.db %01110110 
	.db %01111101 
	.db %01111110 
	.db %00000000 
	.db %10101011
	.db %01010101
	.db %00101001
	.db %00010001
	.db %11011110
	.db %10111110
	.db %01111110
	.db %00000000

patchnumber:
	.db 0
dataword:
	.dw 0
tempvar1:	
	.db 0
tempvar2:
	.db 0
keyvar:
	.db 0
loadstringtempmem:
	.dw 0,0,0,0,0
spritenum:
	.db 0
startofpatches:
	.dw 0
stringsize:
	.dw 0
cursize:
	.db 0
spriteoffset:
	.db 0
allpatchcheck:
	.db 0
curbyte:
	.db 0
curchange:
	.db 0
endofsprites:
	.db 0
tempstringspot:
	.dw 0,0,0,0,0,0

#include "spatch.asm"
#include "subroutes.asm"

.end
