
drawtitle:
	call _clrLCD
	ld de, 0
	ld hl,SharkLogo							;GPS the first 8x8 sprite
	call GridPutSprite
	push ix
	pop hl
	ld de, $0001
	call GridPutSprite						;go right one, and GPS the next section
	push ix
	pop hl
	ld de, $0100
	call GridPutSprite						;go down one from original position, and GPS the next
	ld hl, SharkLogo+24
	ld de, $0101
	call GridPutSprite						;go right one, and GPS the last section
	ld de, $0013
	ld hl, ShellTitle
	call drawstring
	ld de, $0913
	call drawstring
	ld de, $1101
	ld hl, $fd80		;automatically does the Hline routine

Hline:
	ld b, 16
	ld a, 255
HLloop:
	ld (hl), a								;load 255 into the 16 already pointed to bytes,
	inc hl									;figure it out!
	djnz HLloop
	ret

clearspot:					;clears the temporary string spot
	ld de, tempstringspot
	xor a
	ld b, 12
cspotloop:
	ld (de), a
	inc de
	djnz cspotloop
	ret

;This is a great subroutine I took from Dragon Quest!
blinkselect: ;Requires uplimit as c, downlimit as b, increment as d, and a as starting x-pos
	ld (tempvar1), a
	ld a, d
	ld (increment), a
	ld (uplimit), bc
	ld a, b
	ld (tempvar2), a
ynloop:
	call waitkey
	ld hl, selector
	ld de, (tempvar1)
	call drawstring
	push hl
	push de
	ld b, 60
	call keyloop
	pop de
	pop hl
	call drawstring
	ld a, (keyvar)
	or a
	jr nz, ynwindowloop2
	jr ynloop
ynwindowloop2:
	ld a, (increment)
	ld b, a
	ld a, (keyvar)
	cp 1
	jr z, yndown
	cp 4
	jr z, ynup
	cp 6
	jr z, sendbackans
	cp 5
	jr z, exitpress
	ld a, (tempvar1)			;a little, uh, added code (just for the shark!)
	cp 1
	jr nz, ynloop
	ld a, (keyvar)
	cp 10
	jr z, f1press				;hee hee
	jr ynloop
ynup:
	ld a, (downlimit)
	ld c, a
	ld a, (tempvar2)
	cp c
	jr z, loadlimit2
	sub b
	ld (tempvar2), a
	jr ynloop
yndown:
	ld a, (uplimit)
	ld c, a
	ld a, (tempvar2)
	cp c
	jr z, loadlimit
	add a, b
	ld (tempvar2), a
	jr ynloop
loadlimit:
	ld a, (downlimit)
finishlimit:
	ld (tempvar2), a
	jr ynloop
loadlimit2:
	ld a, (uplimit)
	jr finishlimit
sendbackans:
	call waitkey
	ld a, (downlimit)				;custom menu item select return routine. returns a=(selection y-downlimit)/increment. get it?
	ld b, a
	ld a, (tempvar2)
	sub b
	ld l, a
	ld h, 0
	ld a, (increment)
	call _divHLbyA
	ld a, l
	ret
f1press:
	call waitkey
	ld a, 254
	ret
exitpress:
	call waitkey
	ld a, 255
	ret
uplimit:
	.db 0
downlimit:
	.db 0
increment:
	.db 0
selector:
	.db 5, 0
space:
	.db "    ", 0

;Good luck finding a program I don't have this in!
keyloop:
	xor a												;most of games processing goes here, because it doubles as a null loop
	ld (keyvar), a
keyloopb:
	push bc
	ld b, 50
keyloop2:
 	ld a,%1111110
	out (1),a
 	nop
 	in a,(1)
	ld e, 1
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
	ld a,%00111111
	out (1), a
	nop
	in a, (1)
	and %01000000
	call z, ldkey
	inc e
	in a, (1)
	ld h, a
	and %00100000
	call z, ldkey
	inc e
	ld a,%01111101
	out (1), a
	nop
	in a, (1)
	ld l, a
	and %00000010
	call z, ldkey
	inc e
	ld a, l
	and %00000100
	call z, ldkey
	inc e
	ld a,%01011111
	out (1), a
	nop
	in a,(1)
	and %10000000
	call z, ldkey
	ld a, h
	inc e
	and %00010000
	call z, ldkey
	ld a, h
	inc e
	and %00001000
	call z, ldkey
	djnz keyloop2
	pop bc
	djnz keyloopb
	ld a, (keyvar)
	ret
ldkey:
	ld d, a
	ld a, e
	ld (keyvar), a
	ld a, d
	ret
; keys:
; 0=nothing
; 1=down
; 2=left
; 3=right
; 4=up
; 5=exit
; 6=2nd
; 7=plus
; 8=minus
; 9=alpha
; 10=f1
; 11=f2
;generally quick and easy routines :)


waitkey:
	ld b, 1
	call keyloop
	or a
	jr nz, waitkey
	ret

savestring						;deletes original patch string, recreates it, then saves it, if
								;it wasn't deleted the string would never get smaller (when you
								;delete minipatches)
	ld hl, loadstringtempmem
	rst 20h
	rst 10h
	call _delvar
	ld hl, (stringsize)
	inc hl
	inc hl
	call _createstrng
	ld hl, loadstringtempmem
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_dest_addr
	ld a,1
	ld hl,$0100
	call _set_abs_src_addr
	ld hl, (stringsize)
	xor a
	call _set_mm_num_bytes
	call _mm_ldir
	jp _ram_page_1

loadstring:
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_src_addr
	ld a,1
	ld hl,$0100
	call _set_abs_dest_addr
	xor a
	ld hl,$2E40
	call _set_mm_num_bytes
	call _mm_ldir
	call _ram_page_1
	ld hl, $8104
	ret

GridPutSprite:
    push hl                ; push hl to stack...                
    pop ix                 ; ...and pop it into ix
    srl d                  ; de = (128 * y) + x
    rra                    ; carry flag -&lg; msb of a
    and $80                ; a is either $00 or $80   
    or e                   ; add x offset (remember x <= 15)
    ld e,a                 ; de = (128 * y) + (x * 8)
    ld hl,$fc00            ; hl-> video memory
    add hl,de              ; hl-> video memory + offset
    ld b,8                 ; initialize loop counter
    ld de,16               ; screen is 16 bytes wide
GPS_Loop:
    ld a,(ix + 0)          ; get byte from sprite
    ld (hl),a              ; put byte on screen
    inc ix                 ; move to next byte in sprite
    add hl,de              ; move to next line on screen
    djnz GPS_Loop          ; loop until sprite is drawn
    ret                    ; return

drawstring:
	ld (_penCol), de
	push de
	call _vputs
	pop de
	ret

.end
